IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GERA_REANALISE' AND
	        TYPE = 'P' 			       AND
	        U.UID = O.UID             AND
	        U.NAME = USER)

DROP PROCEDURE GERA_REANALISE
GO

CREATE PROCEDURE GERA_REANALISE
AS
   DECLARE @V_IDGERAREANALISE  VARCHAR(1);
   DECLARE @V_SEQUENCIAL       VARCHAR(20);
   DECLARE @V_DTVALANA         VARCHAR(50);
   DECLARE @V_AUDITORIA        VARCHAR(10);
   DECLARE @V_NEWNRINSPECAUDI  VARCHAR(3);
   DECLARE @V_DSLIMIINSP       VARCHAR(50);
   DECLARE @V_CONTRESP         VARCHAR(10);
   DECLARE @V_DSERROINSPECPROD VARCHAR(700);
   DECLARE @V_DSERRORESPOS     VARCHAR(700);
   DECLARE @V_DSERRO           VARCHAR(700);
   DECLARE @V_CDRESPINSPEC     VARCHAR(5);
   DECLARE @V_NMRESPINSPEC     VARCHAR(50);
   DECLARE @V_VRPONTRESINS     DOUBLE PRECISION;;
   DECLARE @V_IDFAIXRESINS     VARCHAR(1);
   DECLARE @V_VRINIFAIXRES     DOUBLE PRECISION;
   DECLARE @V_VRFINFAIXRES     DOUBLE PRECISION;;
   DECLARE @V_EXISTITEM        NUMERIC;
   DECLARE @V_CONTITEM         NUMERIC;
   DECLARE @V_DTPRXCONSULTA    DATETIME;
   DECLARE @V_COUNTINSPECPROD  NUMERIC;
   DECLARE @V_COUNTRESPOSTA    NUMERIC;
   DECLARE @V_NEWSEQERRO       NUMERIC;
   DECLARE @V_EXISTERESPOSTA   NUMERIC;
   DECLARE @V_SEQ              VARCHAR(19);

/*VARIVEIS DO CURSOR C_AUDITORIA*/
   DECLARE @V_AUDITORIA_CDFILIAL     VARCHAR(4);
   DECLARE @V_AUDITORIA_NRAUDITORIA  VARCHAR(10);
   DECLARE @V_AUDITORIA_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_AUDITORIA_NRSUBLOTE    VARCHAR(4);
   DECLARE @V_AUDITORIA_IDTPAUDITADO VARCHAR(1);
   DECLARE @V_AUDITORIA_CDPRODUTO    VARCHAR(10);
   DECLARE @V_AUDITORIA_NRDIASVALANA DOUBLE PRECISION;
   DECLARE @V_AUDITORIA_QTAMOSAUDI   DOUBLE PRECISION;

/*VARIVEIS DO CURSOR C_INSPECPROD */
   DECLARE @V_INSPECPROD_CDSETOR VARCHAR(4);
   DECLARE @V_INSPECPROD_IDORIGINSPEC VARCHAR(1);
   DECLARE @V_INSPECPROD_CDNVINSPECAO VARCHAR(1);
   DECLARE @V_INSPECPROD_IDPROCPROD VARCHAR(1);
   DECLARE @V_INSPECPROD_CDINSPECAO VARCHAR(10);
   DECLARE @V_INSPECPROD_CDARVINSPEC VARCHAR(10);

/*VARIVEIS DO CURSOR C_INSPECRESP */
   DECLARE @V_INSPECRESP_CDINSPECAO   VARCHAR(10);
   DECLARE @V_INSPECRESP_CDTIPOAMOS   VARCHAR(3);
   DECLARE @V_INSPECRESP_IDTPRESPINSP VARCHAR(4);
   DECLARE @V_INSPECRESP_CDRESPINSPEC VARCHAR(5);
   DECLARE @V_INSPECRESP_IDATEITEINSP VARCHAR(1);

/* VARIVEIS DO CURSOR C_BUSCAINSPECAO */
   DECLARE @V_BUSCAINSPECAO_CDFILIAL     VARCHAR(4);
   DECLARE @V_BUSCAINSPECAO_NRINSPECAUDI VARCHAR(3);
   DECLARE @V_BUSCAINSPECAO_CDINSPECAO   VARCHAR(10);

BEGIN

   -- BUSCA AS ANLISES VENCIDAS
   DECLARE C_AUDITORIA CURSOR FOR SELECT A.CDFILIAL, A.NRAUDITORIA, A.NRLOTEESTQ, A.NRSUBLOTE,
                                         A.IDTPAUDITADO, A.CDPRODUTO, ISNULL(P.NRDIASVALANA, 0) AS NRDIASVALANA, A.QTAMOSAUDI
                                    FROM AUDITORIA A, PRODUTO P
                                   WHERE A.CDPRODUTO = P.CDPRODUTO
                                     AND A.DTVALANA < GETDATE()
                                     AND A.IDORIGAUDIT = 'ANA'
                                     AND A.IDSTATUSAUDI IN (4,5)
                                     AND ISNULL(A.IDGERADOREANA, 'N') = 'N';

      OPEN C_AUDITORIA;
      FETCH NEXT FROM C_AUDITORIA INTO @V_AUDITORIA_CDFILIAL, @V_AUDITORIA_NRAUDITORIA, @V_AUDITORIA_NRLOTEESTQ, @V_AUDITORIA_NRSUBLOTE,
                                    @V_AUDITORIA_IDTPAUDITADO, @V_AUDITORIA_CDPRODUTO, @V_AUDITORIA_NRDIASVALANA, @V_AUDITORIA_QTAMOSAUDI;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_DSERROINSPECPROD = NULL;
         SET @V_DSERRORESPOS     = NULL;
         SET @V_EXISTITEM        = 0;
         SET @V_EXISTERESPOSTA   = 0;

         -- Verifica se o parmetro est marcado para gerar a reanlise
         SELECT @V_IDGERAREANALISE = ISNULL(IDGERAREANALISE, 'N')
           FROM PARAMETROQPR
          WHERE CDFILIAL = @V_AUDITORIA_CDFILIAL;

         IF (@V_IDGERAREANALISE = 'S') BEGIN
            -- INSERE A AUDITORIA/REANLISE

            SET @V_SEQ =  ('AUDITORIA'+@V_AUDITORIA_CDFILIAL);
            EXEC NOVO_CODIGO_SC @V_SEQ , @V_SEQUENCIAL OUTPUT, 1;
            SET @V_SEQUENCIAL = SUBSTRING( @V_SEQUENCIAL,11,10);

            SET @V_DTVALANA = CONVERT(VARCHAR, GETDATE() + (@V_AUDITORIA_NRDIASVALANA*30) , 103);

            --  INSERIR AUDITORIA
            INSERT INTO AUDITORIA
            (NRLOTEESTQ,   NRSUBLOTE,    CDPRODUTO,
            IDSTATUSAUDI,  CDFILIAL, DTINCLAUDIT, QTAMOSAUDI,
            NRAUDITORIA,  IDORIGAUDIT,  CDSETEXECAUD,  DSREFEAUDIT,
            IDLIBERAUDIT,   IDTPAUDITADO, DTVALANA, IDGERADOJOB, IDTIPOANA)
            values
            (@V_AUDITORIA_NRLOTEESTQ,   @V_AUDITORIA_NRSUBLOTE, @V_AUDITORIA_CDPRODUTO,
            '1', @V_AUDITORIA_CDFILIAL,  GETDATE(), @V_AUDITORIA_QTAMOSAUDI,
            @V_SEQUENCIAL,  'ANA',  '', 'Reanlise gerada automaticamente',
            'S', @V_AUDITORIA_IDTPAUDITADO, @V_DTVALANA, 'S', 'R');
            SET @V_AUDITORIA = @V_SEQUENCIAL;

            SELECT @V_COUNTINSPECPROD = ISNULL(COUNT(*),0)
              FROM INSPECAO ICAO,
                   INSPECPROD IPRO
             WHERE (IPRO.CDPRODUTO    = @V_AUDITORIA_CDPRODUTO)  AND
                   (IPRO.CDINSPECAO   = ICAO.CDINSPECAO)        AND
                   (IPRO.IDPROCPROD = @V_AUDITORIA_IDTPAUDITADO) AND
                   (ICAO.IDORIGINSPEC = 'ANA')                  AND
                   (ICAO.IDSITINSPEC = 'A')                     AND
                   (IPRO.IDSTATUSINSPEC = 'A');

            IF (@V_COUNTINSPECPROD = 0) BEGIN
               SET @V_DSERROINSPECPROD = 'No existe cadastro na tela de ProdutoXAnlise ou os cadastros se encontram inativos';
            END;

             -- VERIFICA SE EXISTE INSPECAO
            DECLARE C_INSPECPROD CURSOR FOR SELECT IPRO.CDSETOR, ICAO.IDORIGINSPEC, ICAO.CDNVINSPECAO, IPRO.IDPROCPROD,
                                                   ICAO.CDINSPECAO, ICAO.CDARVINSPEC
                                              FROM INSPECAO ICAO,
                                                   INSPECPROD IPRO
                                             WHERE (IPRO.CDPRODUTO      = @V_AUDITORIA_CDPRODUTO)  AND
                                                   (IPRO.CDINSPECAO     = ICAO.CDINSPECAO)        AND
                                                   (IPRO.IDPROCPROD     = @V_AUDITORIA_IDTPAUDITADO) AND
                                                   (ICAO.IDORIGINSPEC   = 'ANA')                  AND
                                                   (ICAO.IDSITINSPEC    = 'A')                     AND
                                                   (IPRO.IDSTATUSINSPEC = 'A')
                                            ORDER BY IPRO.CDSETOR;
               OPEN C_INSPECPROD;
               FETCH NEXT FROM C_INSPECPROD INTO @V_INSPECPROD_CDSETOR, @V_INSPECPROD_IDORIGINSPEC, @V_INSPECPROD_CDNVINSPECAO, @V_INSPECPROD_IDPROCPROD,
                                    @V_INSPECPROD_CDINSPECAO, @V_INSPECPROD_CDARVINSPEC;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  -- INSERE A INSPECAO DA AUDITORIA
                  SELECT @V_NEWNRINSPECAUDI = RIGHT(REPLICATE('0',3) + ISNULL(MAX(NRINSPECAUDI), '0'), 3)
                    FROM INSPECAUDIT
                   WHERE CDFILIAL   = @V_AUDITORIA_CDFILIAL
                    AND NRAUDITORIA = @V_AUDITORIA;

                  INSERT INTO INSPECAUDIT
                  (CDFILIAL, NRAUDITORIA,  NRINSPECAUDI, IDINSPCONC,
                   CDINSPECAO, DSINSPECAUDI, IDNOVAAMOSTR, IDTIPOINSAUD)
                  VALUES
                  (@V_AUDITORIA_CDFILIAL, @V_AUDITORIA,  @V_NEWNRINSPECAUDI, 'P',
                   @V_INSPECPROD_CDINSPECAO, '', 'N', 'R');

                  SELECT @V_COUNTRESPOSTA = ISNULL(COUNT(*),0)
                    FROM RESPOSINSPEC R, INSPECAO I
                   WHERE (I.CDARVINSPEC LIKE (@V_INSPECPROD_CDARVINSPEC + '%')) AND
                         (I.IDSITINSPEC  = 'A')                                  AND
                         (R.CDINSPECAO   = I.CDINSPECAO)                         AND
                         (R.CDPRODUTO    = @V_AUDITORIA_CDPRODUTO)               AND
                         (R.IDSTATUSRESP = 'A')                                  AND
                         (I.IDATEITEINSP = 'I');

                  IF (@V_COUNTRESPOSTA = 0) AND (@V_EXISTERESPOSTA = 0) THEN
                     SET @V_DSERRORESPOS   =  'No existe resposta cadastrada ou ativa para a inspeo.';
                     SET @V_EXISTERESPOSTA = 0;
                  END
                  ELSE BEGIN
                     SET @V_EXISTERESPOSTA = 1;
                  END;

                  -- BUSCA AS RESPOSTAS
                  DECLARE C_INSPECRESP CURSOR FOR SELECT I.CDINSPECAO, I.CDTIPOAMOS, I.IDTPRESPINSP, R.CDRESPINSPEC, I.IDATEITEINSP
                                                    FROM RESPOSINSPEC R, INSPECAO I
                                                   WHERE (I.CDARVINSPEC LIKE (@V_INSPECPROD_CDARVINSPEC + '%')) AND
                                                         (I.IDSITINSPEC  = 'A')                                 AND
                                                         (R.CDINSPECAO   = I.CDINSPECAO)                        AND
                                                         (R.CDPRODUTO    = @V_AUDITORIA_CDPRODUTO)               AND
                                                         (R.IDSTATUSRESP = 'A')                                 AND
                                                         (I.IDATEITEINSP = 'I')
                                                       ORDER BY I.CDINSPECAO, R.VRPONTRESINS;
                     OPEN C_INSPECRESP;
                     FETCH NEXT FROM C_INSPECRESP INTO @V_INSPECRESP_CDINSPECAO, @V_INSPECRESP_CDTIPOAMOS, @V_INSPECRESP_IDTPRESPINSP,
                                                       @V_INSPECRESP_CDRESPINSPEC, @V_INSPECRESP_IDATEITEINSP;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        SET @V_DSLIMIINSP = '';
                        IF (@V_INSPECRESP_IDTPRESPINSP = 'VALR') BEGIN
                           SELECT @V_CDRESPINSPEC = CDRESPINSPEC, @V_NMRESPINSPEC = NMRESPINSPEC, @V_VRPONTRESINS = VRPONTRESINS,
                                   @V_IDFAIXRESINS = IDFAIXRESINS,
                                  @V_VRINIFAIXRES = VRINIFAIXRES, @V_VRFINFAIXRES =VRFINFAIXRES
                             FROM RESPOSINSPEC
                            WHERE (CDINSPECAO   = @V_INSPECRESP_CDINSPECAO)     AND
                                  (CDPRODUTO    = @V_AUDITORIA_CDPRODUTO  )     AND
                                  (IDRESPPROC   = @V_INSPECPROD_IDPROCPROD)     AND
                                  (VRPONTRESINS = '0')                       AND
                                  (CDRESPINSPEC = @V_INSPECRESP_CDRESPINSPEC) AND
                                  (IDSTATUSRESP = 'A');

                           IF NOT (@V_CDRESPINSPEC IS NULL) BEGIN
                              IF (@V_IDFAIXRESINS = '>') BEGIN
                                 SET @V_DSLIMIINSP = 'Maior que '+CONVERT(VARCHAR, @V_VRINIFAIXRES);
                              END
                              ELSE IF (@V_IDFAIXRESINS) = '<' BEGIN
                                 SET @V_DSLIMIINSP = 'Menor que '+CONVERT(VARCHAR, @V_VRINIFAIXRES);
                              END
                              ELSE IF (@V_IDFAIXRESINS = '=') BEGIN
                                 SET @V_DSLIMIINSP = 'Entre '+CONVERT(VARCHAR, @V_VRINIFAIXRES)+' e '+CONVERT(VARCHAR, @V_VRFINFAIXRES);
                              END
                              ELSE
                                 SET @V_DSLIMIINSP = '';
                           END;
                        END;

                        SELECT @V_EXISTITEM = ISNULL(COUNT(*),0)
                          FROM ITEMINSAUDIT
                         WHERE CDFILIAL = @V_AUDITORIA_CDFILIAL
                           AND NRAUDITORIA = @V_AUDITORIA
                           AND NRINSPECAUDI = @V_NEWNRINSPECAUDI
                           AND CDINSPECAO = @V_INSPECRESP_CDINSPECAO;

                        IF (@V_EXISTITEM = 0) BEGIN
                           INSERT INTO ITEMINSAUDIT
                           (CDFILIAL,      NRAUDITORIA,   NRINSPECAUDI,    CDINSPECAO,
                            IDOPCACEITIN,  DSOBSINSAUDI, DSLIMIINSP)
                           VALUES
                           (@V_AUDITORIA_CDFILIAL,  @V_AUDITORIA,  @V_NEWNRINSPECAUDI,  @V_INSPECRESP_CDINSPECAO,
                            'P',  '', @V_DSLIMIINSP);
                        END;


                     FETCH NEXT FROM C_INSPECRESP INTO @V_INSPECRESP_CDINSPECAO, @V_INSPECRESP_CDTIPOAMOS, @V_INSPECRESP_IDTPRESPINSP,
                                                       @V_INSPECRESP_CDRESPINSPEC, @V_INSPECRESP_IDATEITEINSP;
                  END;
                  CLOSE C_INSPECRESP;
                  DEALLOCATE C_INSPECRESP;
               FETCH NEXT FROM C_INSPECPROD INTO @V_INSPECPROD_CDSETOR, @V_INSPECPROD_IDORIGINSPEC, @V_INSPECPROD_CDNVINSPECAO, @V_INSPECPROD_IDPROCPROD,                                                 @V_INSPECPROD_CDINSPECAO, @V_INSPECPROD_CDARVINSPEC;
            END;
            CLOSE C_INSPECPROD;
            DEALLOCATE C_INSPECPROD;

            -- EXLUI AS INSPECOES DA AUDITORIA QUE NAO POSSUEM ITEM DO TIPO INDISPENSVEL
            DECLARE C_BUSCAINSPECAO CURSOR FOR SELECT CDFILIAL, NRINSPECAUDI, CDINSPECAO
                                                 FROM INSPECAUDIT
                                                WHERE NRAUDITORIA = @V_AUDITORIA;

               OPEN C_BUSCAINSPECAO;
               FETCH NEXT FROM C_BUSCAINSPECAO INTO @V_BUSCAINSPECAO_CDFILIAL, @V_BUSCAINSPECAO_NRINSPECAUDI, @V_BUSCAINSPECAO_CDINSPECAO;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_CONTITEM = ISNULL(COUNT(*),0)
                    FROM ITEMINSAUDIT
                   WHERE CDFILIAL     = @V_AUDITORIA_CDFILIAL
                     AND NRAUDITORIA  = @V_AUDITORIA
                     AND NRINSPECAUDI = @V_BUSCAINSPECAO_NRINSPECAUDI;

                  IF (@V_CONTITEM = 0) BEGIN
                     DELETE FROM INSPECAUDIT
                       WHERE CDFILIAL     = @V_BUSCAINSPECAO_CDFILIAL
                         AND NRAUDITORIA  = @V_AUDITORIA
                         AND NRINSPECAUDI = @V_BUSCAINSPECAO_NRINSPECAUDI;
                  END;

                  FETCH NEXT FROM C_BUSCAINSPECAO INTO @V_BUSCAINSPECAO_CDFILIAL, @V_BUSCAINSPECAO_NRINSPECAUDI, @V_BUSCAINSPECAO_CDINSPECAO;
            END;
            CLOSE C_BUSCAINSPECAO;
            DEALLOCATE C_BUSCAINSPECAO;

            -- Se ocorrer algum erro, a auditoria no  inserida e o erro  gravado no banco
            IF (@V_DSERROINSPECPROD IS NULL) AND (@V_DSERRORESPOS IS NULL OR @V_EXISTERESPOSTA = 1) BEGIN
               --ALTERA A AUDITORIA PARA QUE NO SEJA GERADA OUTRA REANLISE PARA ELA
               UPDATE AUDITORIA
                 SET IDGERADOREANA = 'S'
                WHERE CDFILIAL = @V_AUDITORIA_CDFILIAL
                  AND NRAUDITORIA = @V_AUDITORIA_NRAUDITORIA;
                COMMIT;

            END
            ELSE BEGIN
               ROLLBACK;
               IF (@V_DSERROINSPECPROD IS NULL) BEGIN
                  SET @V_DSERRO = @V_DSERRORESPOS;
               END
               ELSE BEGIN
                  SET @V_DSERRO = @V_DSERROINSPECPROD;
               END;

               SELECT @V_NEWSEQERRO = RIGHT(REPLICATE('0',3) + ISNULL(MAX(NRSEQERRO), '0'), 3)
                 FROM ERROGERAREANA
                WHERE CDFILIAL = @V_AUDITORIA_CDFILIAL;

               INSERT INTO ERROGERAREANA
               (NRSEQERRO, CDFILIAL, NRAUDITORIA, DSERRO, DTERRO)
               VALUES
               (@V_NEWSEQERRO, @V_AUDITORIA_CDFILIAL, @V_AUDITORIA_NRAUDITORIA, @V_DSERRO, GETDATE());
               COMMIT;
            END;
         END;
      FETCH NEXT FROM C_AUDITORIA INTO @V_AUDITORIA_CDFILIAL, @V_AUDITORIA_NRAUDITORIA, @V_AUDITORIA_NRLOTEESTQ, @V_AUDITORIA_NRSUBLOTE,
                                       @V_AUDITORIA_IDTPAUDITADO, @V_AUDITORIA_CDPRODUTO, @V_AUDITORIA_NRDIASVALANA, @V_AUDITORIA_QTAMOSAUDI;
   END;

   CLOSE C_AUDITORIA;
   DEALLOCATE C_AUDITORIA;

   -- Atualiza a data da consulta no banco
   UPDATE PARAMETROQPR
     SET DTULTCONSULTA = GETDATE();
   COMMIT;
END;

